// ================================================== //
//        Contact Center IVR interface module         //
//                    Version 2.2.5                   //
//                                                    //
// ---------- (c) AO SBK 2015-2022 ---------- //
// ================================================== //

var curIvr = null;
var langNum = 3;
var buttonList = new Array(1,2,3,4,5,6,7,8,9,0,'*','#','invalid');
var fileListCont = null;
var ivrTableName = '*';
var ivrTable = {};
/*
$(document).on('scroll', function() {
  var top = $(document).scrollTop();
  if(top >= 263) {
    var width = $('.pbxFiles').width();
    $('.pbxFiles').addClass('stickList');
    $('.pbxFiles').css('width', width);
  } else {
    $('.pbxFiles').removeClass('stickList');
    $('.pbxFiles').removeAttr('style');
  }
});
*/

function listIvr() {
  $('#tabIvr').html(
    '<div class="ivrListContainer right onethirdwidth bg standheight"><div class="marg20">' +
    '<h2>' + translate('ivrlist') + ' ' + domainName + '</h2><i class="description">' +
    translate('ivrlistinstruction') + '</i><br /><div>' +
    '<div class="scrollList"><div id="ivrList"><div class="loader"></div></div></div></div><p>' +
    '<button id="create_ivr" class="button ff0">' + translate('create') + ' ' +
    translate('ivrmenu') + '</button>&nbsp;' +
    '<input type="text" class="ivrNameNew input bg" size="8" /></p></div></div>' +
    '<div id="defaultIvr" class="bg left twothirdwidth bg standheight">' +
    '<h2 style="margin: 100px 20px 0px; text-align: center;">' +
    translate('defaultivrdescription') + '<br /><br /><img src="' + filesRef +
    'arrowright.svg" /></h2></div>'
  );
  $('#create_ivr').on('click', function() {
    var ivrNameNew = $('.ivrNameNew').val().toLowerCase();
    $('.ivrNameNew').val('');
    if(!ivrNameNew || ivrNameNew == ivrTableName) return;
    createObject('ivr', ivrNameNew, defaultIvrSettings);
    curIvr = ivrNameNew;
    var c = $('.ivrSettings');
    if(!c.length) {
      $('#tabIvr').append(
        '<div class="ivrSettings bg standheight left twothirdwidth">' +
        '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
        '<div class="loader"></div></div>'
      );
    } else {
      c.html('<a class="closeIcon right pointer marg20" title="' + translate('close') +
        '"></a><div class="loader"></div>'
      );
    }
    c.find('.closeIcon').on('click', function() {
      $(this).parent().remove();
      ivrList.find('.bg').removeClass('bg');
    });
  });
  getSettings('ivr', ivrTableName);
  getIvrs();
}

function displayIvrSettings(o) {
  if(o.name == ivrTableName) {
    ivrTable = o.settings;
    return;
  }
  // get ivrTable
  getSettings('ivr', ivrTableName);
  // get numbers
  var n = $('#ivrList tr.bg td:last-child').text();
  var c = $('.ivrSettings');
  var h = '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
    '<a href="' + filesRef + 'ivr' + (lang == 'russian' ? lang : '') + '.jpg" target="_blank" class="right yellow border marg20">' + translate('ivrdiagram') + '</a>' +
    '<div class="marg20" style="display:none"><h2 class="ivrName"></h2><br />' +
    '<div class="detals">' +
    '<ul class="list_settings clr">' +
    '<li class="bg"><p class="head bg"><a>' + translate('ivrnumbers') + '</a></p><div class="detals ivrBlock">' +
    '<table><tr><td width="300px"><h3 class="grey">' +
    translate('ivrnumbers') +
    '</h3><i class="description">' + translate('ivrnuminstruction') + '</i></td><td>' +
    '<input id="ivrNums" type="text" class="input bg" size="20" value="' + n + '" /></td></tr>' +
    '</table></div></li>' +
    '<li class="bg"><p class="head bg"><a>' + translate('timeperiod') + '</a></p><div class="detals ivrBlock">';
    /*
    '<div id="slider_time24ivr">' +
    '<i class="start">0 ' + translate('hours') + '</i>' +
    '<i class="end">24 ' + translate('hours') + '</i>' +
    '</div><i class="description" style="text-align: center; width: 480px; margin-left: 10px">' +
    '<span id="invRange" class="border pointer">' + translate('invrange') + '</span></i>' +
    '<input type="hidden" id="tStart" /><input type="hidden" id="tEnd" />' +
    '<h3 class="grey">' + translate('ifnotactive') + '</h3>' +
    '<p id="onMissed">' + '<span>' + ivr_actions() + '</span><span style="margin-left: 20px;">' +
    '<span class="param">' + ivr_action_params() + '</span></span></p>' +
    '<p id="weekDays">' +
    translate('M') + ' <input value="Mon" type="checkbox" /> ' +
    translate('T') + ' <input value="Tue" type="checkbox" /> ' +
    translate('W') + ' <input value="Wed" type="checkbox" /> ' +
    translate('T') + ' <input value="Thu" type="checkbox" /> ' +
    translate('F') + ' <input value="Fri" type="checkbox" /> ' +
    '<span class="red">' + translate('S') + '</span>' +
    ' <input value="Sat" type="checkbox" /> ' +
    '<span class="red">' + translate('S') + '</span>' +
    ' <input value="Sun" type="checkbox" /> ' +
    '</p>' +
    */
  var dnames = '';
  for(var i = 0; i < translate('daynames').length; i++) {
    dnames += translate('daynames')[i] + ' <input value="' + weekStandard[i] + '" type="checkbox" /> ';
  }
  var timeFrame = translate('timeFrom') + ' ' + make_select('hrs', 'HrsFrom') + ' : ' + make_select('mnts', 'MntsFrom') + ' ' + translate('timeTo') + ' ' + make_select('hrs', 'HrsTo') + ' : ' + make_select('mnts', 'MntsTo');
  h += '<p><a id="addTF" class="border yellow pointer">' + translate('addTimeFrame') + '</a></p>' +
    '<h3 class="grey">' + translate('ifnotactive') + '</h3>' +
    '<p id="onMissed">' + '<span>' + ivr_actions() + '</span><span style="margin-left: 20px;">' +
    '<span class="param">' + ivr_action_params() + '</span></span>' + ivr_preplay() + '</p>' +
    '<h3 class="grey">' + translate('holidays') + '</h3>' +
    '<p><a id="addHD" class="border yellow pointer">' + translate('addHoliday') + '</a></p>' +
    '</div></li>' +
    '<li class="bg"><p class="head bg"><a>' + translate('languagemenu') + '</a></p><div class="detals ivrBlock">' +
    '<table width="100%" id="languages" cellspacing="10" cellpadding="10">';
  for(var i = 1; i <= langNum; i++) {
    h += '<tr data-value="' + i + '"><td width="5%">' + i +
      '</td><td nowrap="nowrap" width="10%">' +
      ivr_lang() + '</td><td><span class="sound"><span class="fileList"></span> ' +
      '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></span>' +
      '</td></tr>';
  }
  h += '</table></div></li>' +
    '<li class="bg"><p class="head bg"><a>' + translate('playatstartonce') + '</a></p><div class="detals ivrBlock">' +
    '<p id="playAtStart">' +
    '<span class="fileList"></span> ' +
    '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></p></div></li>' +
    '<li class="bg"><p class="head bg"><a>' + translate('dialinext') + '</a></p><div class="detals ivrBlock">' +
    '<table width="100%" id="DED"><tr>' +
    '<td nowrap="nowrap" width="33%%">' + translate('directextdialing') + ' ' +
    make_select('onoff', 'DED') +
    '</td><td width="33%">' + translate('DEDtimeout') + ' ' + make_select('dedtout', 'DEDtimeout', null, 5) + '</td>' +
    '<td id="DEDsound"><span class="fileList"></span> ' +
    '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></td></tr>' +
    '</table></div></li>' +
    '<li class="bg"><p class="head bg"><a>' + translate('selectionmenu') + '</a></p><div class="detals ivrBlock">' +
    '<div>' +
    '<h3 class="grey">' + translate('playatstarteverytime') + '</h3><p id="playBeforeMenu">' +
    '<span class="fileList"></span> ' +
    '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></p></div>' +
    '<table id="menuButtons" cellspacing="10" cellpadding="10" width="100%"><thead>' +
    '<tr><td nowrap="nowrap" width="5%"><h3 class="grey">' +
    translate('buttons') + '</h3></td>' +
    '<td nowrap="nowrap" width="30%"><h3 class="grey">' +
    translate('soundtoplay') + '</h3></td>' +
    '<td nowrap="nowrap" width="15%"><h3 class="grey">' + translate('action') + '</h3></td>' +
    '<td width="20%"></td><td width="30%"><h3 class="grey">' + translate('preplay') + '</h3></td></tr></thead><tbody>';
  for(var i = 0; i < buttonList.length; i++) {
    h += '<tr data-value="' + buttonList[i] + '"><td>' + (buttonList[i] == 'invalid' ? translate('invalid') : buttonList[i]) + '</td>' +
    '<td><span class="sound"><span class="fileList"></span> ' +
    '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></span></td>' +
    '<td nowrap="nowrap">' + ivr_actions(true) + '</td><td><span class="param">' +
    ivr_action_params() + '</span></td><td>' + ivr_preplay() + '</td></tr>';
  }
  h += '</tbody></table>' +
    '<div><h3 class="grey">' + translate('dialinext') + '</h3>' +
    '<table width="100%" id="DED_"><tr>' +
    '<td nowrap="nowrap" width="20%">' + translate('directextdialing') + ' ' +
    make_select('onoff', 'DED', 'off') +
    '</td><td id="DEDsound_"><span class="fileList"></span> ' +
    '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></td></tr>' +
    '</table></div>' +
    '<div><h3 class="grey">' + translate('playatendeverytime') + '</h3><p id="playAfterMenu">' +
    '<span class="fileList"></span> <a class="addFile yellow border pointer">' +
    translate('addfile') + '</a></p></div></div></li>' +
    '<li class="bg"><p class="head bg"><a>' + translate('playatendonce') + '</a></p><div class="detals ivrBlock">' +
    '<table width="100%"><tr><td nowrap="nowrap" width="15%"><h3 class="grey">' + translate('selectaction') +
    '</h3></td><td></td><td><h3 class="grey">' + translate('preplay') + '</h3></td></tr>' +
    '<tr id="finalAction"><td nowrap="nowrap">' + ivr_actions() + '</td><td>' +
    '<span class="param">' + ivr_action_params() + '</span></td><td>' + ivr_preplay() + '</td></tr></table></div></li></ul>' +
    '<p><button id="update_ivr" class="button ff0">' + translate('update') + '</button>' +
    '<button id="remove_ivr" class="button bg right">' + translate('remove') + '</button></p>' +
    '</div></div>';
  c.html(h);
  $('.ivrSettings .list_settings .head').on('click',function() {
		var t = $(this);
		var li = t.parent();
		if(li.hasClass('active')){
			t.siblings('.close').stop().fadeOut();
			li.removeClass('active');
			li.stop().animate({'height':t.outerHeight()},500);
		}
		else {
			var h = t.outerHeight() + t.siblings('.items').outerHeight() + t.siblings('.turn').outerHeight() + t.siblings('.detals').outerHeight();
			li.addClass('active');
			li.stop().animate({'height':h},700,function(){
				t.stop().siblings('.close').fadeIn();
			});
		}
		return false;
	});
	$('.ivrSettings .list_settings .close').on('click',function() {
		$(this).siblings('.head').trigger('click')
	});
  c.find('#addHD').on('click', function() {
    var t = $(this);
    $(this).parent().before(
      '<table class="hDay" cellspacing="10">' +
      '<tr><td>' + translate('date') + '<i class="description">dd-mm</i></td>' +
      '<td><input class="bg input hDate" type="text" size="10" /></td>' +
      '<td>' + translate('action') + '</td>' +
      '<td nowrap="nowrap">' + ivr_actions(true) + '</td><td><span class="param">' +
      ivr_action_params() + '</span></td><td>' + ivr_preplay() + '</td><td><p class="xIcon pointer"></p></td></tr></table>'
    );
    var sel = $('.hDay:last');
    sel.find('.select').each(function() {
      select_html($(this));
    });
    sel.find('.action').on('change', function() {
      var a = $(this).val();
      var p = null;
      if(a == 'ivr' || a == 'call' || a == 'sendurl') p = 'dest';
      else if(a == 'play') p = 'file';
      if(p) {
        $(this).parent().parent().parent().find('.param .' + p).show().siblings().hide();
      } else {
        $(this).parent().parent().parent().find('.param').children().hide();
      }
    });
    sel.find('.addFile').on('click', function() {
      addFileHandler($(this));
    });
    sel.find('.xIcon').on('click', function() {
      sel.remove();
      var h = t.parents('li').children('.head').outerHeight() + t.parents('.detals').outerHeight();
      t.parents('li').stop().animate({'height':h},700,function(){
        t.parents('li').children('.head').stop().siblings('.close').fadeIn();
      });
    });
    var h = t.parents('li').children('.head').outerHeight() + t.parents('.detals').outerHeight();
    t.parents('li').stop().animate({'height':h},700,function(){
			t.parents('li').children('.head').stop().siblings('.close').fadeIn();
		});
  });
  $('#addTF').on('click', function() {
    var t = $(this);
    $(this).parent().before('<p class="timeFrame">' +
      '<span class="time">' + timeFrame + '</span> <span class="days">' + dnames + '</span><span class="xIcon pointer"></span></p>');
    var sel = $('.timeFrame:last');
    sel.find('.select').each(function() {
      select_html($(this));
    });
    sel.find('input:checkbox').prop('checked', true);
    sel.find('.xIcon').on('click', function() {
      sel.remove();
      var h = t.parents('li').children('.head').outerHeight() + t.parents('.detals').outerHeight();
      t.parents('li').stop().animate({'height':h},700,function(){
        t.parents('li').children('.head').stop().siblings('.close').fadeIn();
      });
    });
    var h = t.parents('li').children('.head').outerHeight() + t.parents('.detals').outerHeight();
    t.parents('li').stop().animate({'height':h},700,function(){
			t.parents('li').children('.head').stop().siblings('.close').fadeIn();
		});
  });
  c.find('.action').on('change', function() {
    var a = $(this).val();
    var p = null;
    if(a == 'ivr' || a == 'call' || a == 'sendurl') p = 'dest';
    else if(a == 'play') p = 'file';
    if(p) {
      $(this).parent().parent().parent().find('.param .' + p).show().siblings().hide();
    } else {
      $(this).parent().parent().parent().find('.param').children().hide();
    }
  });
  c.find('.closeIcon').on('click', function() {
    $(this).parent().remove();
    $('#ivrList .bg').removeClass('bg');
    $('#tabIvr .pbxFiles').remove();
    $('#tabIvr .ivrListContainer').show();
	  $window.trigger('resize');
  });
  c.find('.addFile').on('click', function() {
    addFileHandler($(this));
  });
  c.find('.select').each(function() {
    select_html($(this));
  });
  // slider
  /*
  var tStart = Math.floor(+o.settings.tStart/3600);
  if(isNaN(tStart)) {
    tStart = 0;
  }
  var tEnd = Math.ceil(+o.settings.tEnd/3600);
  if(isNaN(tEnd)) {
    tEnd = 24;
  }
  c.find('#invRange').on('click', function() {
    $('#slider_time24ivr').toggleClass('inv');
    $('#slider_time24ivr .ui-slider-range').toggleClass('inv');
    var value = $('#tStart').val();
    $('#tStart').val($('#tEnd').val());
    $('#tEnd').val(value);
  });
	if($('#slider_time24ivr').is('#slider_time24ivr')) {
		$('#slider_time24ivr').slider({
			range: true,
			min: 0,
			max: 24,
			values: (tStart < tEnd ? [tStart,tEnd] : [tEnd,tStart]),
			slide: function(event,ui) {
				if(ui.values[0] == ui.values[1]) {
          return false;
        }
				var handle = $('#slider_time24ivr .ui-slider-handle');
				handle.first().text(ui.values[0]);
				handle.last().text(ui.values[1]);
        if($('#slider_time24ivr').hasClass('inv')) {
          $('#tStart').val(ui.values[1]);
          $('#tEnd').val(ui.values[0]);
        } else {
          $('#tStart').val(ui.values[0]);
          $('#tEnd').val(ui.values[1]);
        }
			}
		});
		sep(24,$('#slider_time24ivr'));
    if(tStart < tEnd) {
      $('#slider_time24ivr .ui-slider-handle').first().text(tStart);
      $('#slider_time24ivr .ui-slider-handle').last().text(tEnd);
    } else {
      $('#slider_time24ivr .ui-slider-handle').first().text(tEnd);
      $('#slider_time24ivr .ui-slider-handle').last().text(tStart);
    }
	}
  if(tStart > tEnd) {
    $('#slider_time24ivr').toggleClass('inv');
    $('#slider_time24ivr .ui-slider-range').toggleClass('inv');
  }
  //tStart, tEnd
  c.find('#tStart').val(tStart);
  c.find('#tEnd').val(tEnd);
  */
  // propagate settings
  // name
  c.find('.ivrName').text(o.name);
  // time period
  if(o.settings.activePeriods) {
    for(var i = 0; i < o.settings.activePeriods.length; i++) {
      c.find('#addTF').parent().before(
        '<p class="timeFrame">' +
        '<span class="time">' + timeFrame + '</span> <span class="days">' + dnames + '</span>' +
        (i > 0 ? '<span class="xIcon pointer"></span>' : '') + '</p>'
      );
      var sel = $('.timeFrame:last');
      sel.find('.select').each(function() {
        select_html($(this));
      });
      sel.find('.HrsFrom').val(getHrs(o.settings.activePeriods[i].tStart)).trigger('change');
      sel.find('.MntsFrom').val(getMnts(o.settings.activePeriods[i].tStart)).trigger('change');
      sel.find('.HrsTo').val(getHrs(o.settings.activePeriods[i].tEnd)).trigger('change');
      sel.find('.MntsTo').val(getMnts(o.settings.activePeriods[i].tEnd)).trigger('change');
      for(var j = 0; j < o.settings.activePeriods[i].weekDays.length; j++) {
        sel.find('.days input[value="' + o.settings.activePeriods[i].weekDays[j] + '"]').prop('checked', true);
      }
      sel.find('.xIcon').on('click', function() {
        sel.remove();
      });
    }
  }
  // holidays
  if(o.settings.holidays) {
    for(var i = 0; i < o.settings.holidays.length; i++) {
      $('#addHD').parent().before(
        '<table class="hDay" cellspacing="10">' +
        '<tr><td>' + translate('date') + '<i class="description">dd-mm</i></td>' +
        '<td><input class="bg input hDate" type="text" size="10" value="' +
        (o.settings.holidays[i].date && o.settings.holidays[i].date.length ?
          o.settings.holidays[i].date.join(',') : '') + '" /></td>' +
        '<td>' + translate('action') + '</td>' +
        '<td nowrap="nowrap">' + ivr_actions(true) + '</td><td><span class="param">' +
        ivr_action_params() + '</span></td><td>' + ivr_preplay() + '</td><td><p class="xIcon pointer"></p></td></tr></table>'
      );
      var sel = $('.hDay:last');
      sel.find('.select').each(function() {
        select_html($(this));
      });
      sel.find('.action').on('change', function() {
        var a = $(this).val();
        var p = null;
        if(a == 'ivr' || a == 'call' || a == 'sendurl') p = 'dest';
        else if(a == 'play') p = 'file';
        if(p) {
          $(this).parent().parent().parent().find('.param .' + p).show().siblings().hide();
        } else {
          $(this).parent().parent().parent().find('.param').children().hide();
        }
      });
      if(o.settings.holidays[i].action == 'play') {
        // for compatibility with action play file
        sel.find('.action').val('hangup').trigger('change');
        propagateActionParam(sel.find('.preplay'), o.settings.holidays[i].param)
      } else {
        sel.find('.action').val(o.settings.holidays[i].action).trigger('change');
        propagateActionParam(sel.find('.param'), o.settings.holidays[i].param);
        propagateActionParam(sel.find('.preplay'), o.settings.holidays[i].preplay)
      }
      sel.find('.addFile').on('click', function() {
        addFileHandler($(this));
      });
      sel.find('.xIcon').on('click', function() {
        sel.remove();
      });
    }
  }
  // onMissed
  if(o.settings.onMissed.action == 'play') {
    c.find('#onMissed .action').val('hangup').trigger('change');
    propagateActionParam(c.find('#onMissed .preplay'), o.settings.onMissed.param);
  } else {
    c.find('#onMissed .action').val(o.settings.onMissed.action).trigger('change');
    propagateActionParam(c.find('#onMissed .param'), o.settings.onMissed.param);
    propagateActionParam(c.find('#onMissed .preplay'), o.settings.onMissed.preplay);
  }
  // weekDays
  /*
  for(var i = 0; i < o.settings.weekDays.length; i++) {
    c.find('#weekDays input[value="' + o.settings.weekDays[i] + '"]').prop('checked', 'checked');
  }
  */
  // languages
  var languages = Object.keys(o.settings.languages);
  var iKey;
  for(var i = 0; i < languages.length; ++i) {
    iKey = languages[i];
    c.find('#languages tr[data-value="' + iKey + '"] .language').val(o.settings.languages[iKey].lang).trigger('change');
    propagateFileList(
      c.find('#languages tr[data-value="' + iKey + '"] .fileList'),
      o.settings.languages[iKey].sound
    );
  }
  // playAtStart
  propagateFileList(c.find('#playAtStart .fileList'), o.settings.playAtStart);
  // DED
  c.find('#DED .DED').val(o.settings.DED != 'NO' ? 'on' : 'off').trigger('change');
  c.find('#DED .DEDtimeout').val(o.settings.DEDtimeout).trigger('change');
  propagateFileList(c.find('#DEDsound .fileList'), o.settings.DEDsound);
  // playBeforeMenu
  propagateFileList(c.find('#playBeforeMenu .fileList'), o.settings.playBeforeMenu);
  // menuButtons
  var buttons = Object.keys(o.settings.menuButtons);
  for(var i = 0; i < buttons.length; ++i) {
    iKey = buttons[i];
    if(iKey == 'ded') {
      c.find('#DED_ .DED').val('on').trigger('change');
      propagateFileList(c.find('#DEDsound_ .fileList'), o.settings.menuButtons[iKey].sound);
    }
    propagateFileList(
      c.find('#menuButtons tr[data-value="' + iKey + '"] .sound .fileList'),
      o.settings.menuButtons[iKey].sound
    );
    if(o.settings.menuButtons[iKey].action == 'play') {
      c.find('#menuButtons tr[data-value="' + iKey + '"] .action')
        .val('hangup').trigger('change');
      propagateActionParam(
        c.find('#menuButtons tr[data-value="' + iKey + '"] .preplay'),
        o.settings.menuButtons[iKey].param
      );
    } else {
      c.find('#menuButtons tr[data-value="' + iKey + '"] .action')
        .val(o.settings.menuButtons[iKey].action).trigger('change');
      propagateActionParam(
        c.find('#menuButtons tr[data-value="' + iKey + '"] .param'),
        o.settings.menuButtons[iKey].param
      );
      propagateActionParam(
        c.find('#menuButtons tr[data-value="' + iKey + '"] .preplay'),
        o.settings.menuButtons[iKey].preplay
      );
    }
  }
  // playAfterMenu
  propagateFileList(c.find('#playAfterMenu .fileList'), o.settings.playAfterMenu);
  // playAtEnd
  propagateFileList(c.find('#playAtEnd .fileList'), o.settings.playAtEnd);
  // finalAction
  if(o.settings.finalAction.action == 'play') {
    c.find('#finalAction .action').val('hangup').trigger('change');
    propagateActionParam(c.find('#finalAction .preplay'), o.settings.finalAction.param);
  } else {
    c.find('#finalAction .action').val(o.settings.finalAction.action).trigger('change');
    propagateActionParam(c.find('#finalAction .param'), o.settings.finalAction.param);
    propagateActionParam(c.find('#finalAction .preplay'), o.settings.finalAction.preplay);
  }
  c.find('.xIcon').on('click', function() {
    if($(this).hasClass('timePeriod') || $(this).hasClass('timeFrame')) {
      $(this).remove();
    } else {
      $(this).parent().remove();
    }
  });
  // collect settings
  var ivrName = c.find('.ivrName').text();
  c.find('#update_ivr').on('click', function() {
    // check ivrTable
    var nums = c.find('#ivrNums').val().replace(/\s+/g, '').split(',');
    for(var i = 0; i < nums.length; i++) {
      if(ivrTable[nums[i]] && ivrTable[nums[i]] != ivrName) {
        alert(
          nums[i] + ' ' + translate('isassignedtoivr') + ' ' + ivrTable[nums[i]] + '. ' +
          translate('useanother')
        );
        return;
      }
    }
    // remove ivrTable records for current ivr
    var tableKeys = Object.keys(ivrTable);
    for(var i = 0; i < tableKeys.length; ++i) {
      if(ivrTable[tableKeys[i]] == ivrName) delete ivrTable[tableKeys[i]];
    }
    // update ivrTable
    for(var i = 0; i < nums.length; i++) {
      if(isProperNum(nums[i])) {
        ivrTable[nums[i]] = ivrName;
      }
    }
    updateSettings('ivr', ivrTableName, ivrTable);
    var settings = {};
    // time period
    settings.activePeriods = [];
    c.find('.timeFrame').each(function() {
      var p = {};
      p.tStart = +$(this).find('.HrsFrom').val()*3600 + +$(this).find('.MntsFrom').val()*60;
      p.tEnd = +$(this).find('.HrsTo').val()*3600 + +$(this).find('.MntsTo').val()*60;
      p.weekDays = [];
      $(this).find('input:checkbox:checked').each(function() {
        p.weekDays.push($(this).val());
      });
      settings.activePeriods.push(p);
    });
    // holidays
    settings.holidays = [];
    c.find('.hDay').each(function() {
      var h = {};
      h.date = $(this).find('.hDate').val().split(',');
      h.action = $(this).find('.action').val();
      if(h.action == 'play') {
        h.param = getFileList($(this).find('.fileList'));
      } else {
        h.param = $(this).find('.dest').val();
      }
      h.preplay = getFileList($(this).find('.preplay .fileList'));
      settings.holidays.push(h);
    });
    // tStart, tEnd
    /*
    settings.tStart = +c.find('#tStart').val()*3600;
    settings.tEnd = +c.find('#tEnd').val()*3600;
    */
    // onMissed
    settings.onMissed = {};
    settings.onMissed.action = c.find('#onMissed .action').val();
    if(settings.onMissed.action == 'play') {
      settings.onMissed.param = getFileList(c.find('#onMissed .fileList'));
    } else if(settings.onMissed.action == 'call' || settings.onMissed.action == 'ivr') {
      settings.onMissed.param = c.find('#onMissed .dest').val();
    }
    settings.onMissed.preplay = getFileList(c.find('#onMissed .preplay .fileList'));
    // weekDays
    /*
    settings.weekDays = [];
    c.find('#weekDays input:checkbox:checked').each(function() {
      settings.weekDays.push($(this).val());
    });
    */
    // languages
    settings.languages = {};
    c.find('#languages tr').each(function() {
      var l = $(this).find('.language').val();
      if(l) {
        var b = $(this).attr('data-value');
        settings.languages[b] = {};
        settings.languages[b].lang = l;
        settings.languages[b].sound = getFileList($(this).find('.fileList'));
      }
    });
    // playAtStart
    settings.playAtStart = getFileList(c.find('#playAtStart .fileList'));
    // DED
    settings.DED = c.find('#DED .DED').val() == 'on' ? 'YES' : 'NO';
    settings.DEDsound = getFileList(c.find('#DEDsound .fileList'));
    settings.DEDtimeout = c.find('#DED .DEDtimeout').val();
    // playBeforeMenu
    settings.playBeforeMenu = getFileList(c.find('#playBeforeMenu .fileList'));
    // menuButtons
    settings.menuButtons = {};
    c.find('#menuButtons tbody tr').each(function() {
      var a = $(this).find('.action').val();
      if(a) {
        var b = $(this).attr('data-value');
        settings.menuButtons[b] = {};
        settings.menuButtons[b].action = a;
        settings.menuButtons[b].sound = getFileList($(this).find('.sound .fileList'));
        if(a == 'play') {
          settings.menuButtons[b].param = getFileList($(this).find('.param .fileList'));
        } else if(a == 'call' || a == 'ivr' || a == 'sendurl') {
          settings.menuButtons[b].param = $(this).find('.param .dest').val();
        }
        settings.menuButtons[b].preplay = getFileList($(this).find('.preplay .fileList'));
      }
    });
    if(c.find('#DED_ .DED').val() == 'on') {
      settings.menuButtons.ded = {};
      settings.menuButtons.ded.sound = getFileList(c.find('#DEDsound_ .fileList'));
    }
    // playAfterMenu
    settings.playAfterMenu = getFileList(c.find('#playAfterMenu .fileList'));
    // playAtEnd
    settings.playAtEnd = getFileList(c.find('#playAtEnd .fileList'));
    // finalAction
    settings.finalAction = {};
    settings.finalAction.action = c.find('#finalAction .action').val();
    if(settings.finalAction.action == 'play') {
      settings.finalAction.param = getFileList(c.find('#finalAction .fileList'));
    } else if(settings.finalAction.action == 'call' || settings.finalAction.action == 'ivr' || settings.finalAction.action == 'sendurl') {
      settings.finalAction.param = c.find('#finalAction .dest').val();
    }
    settings.finalAction.preplay = getFileList(c.find('#finalAction .preplay .fileList'));
    curIvr = ivrName;
    updateSettings('ivr', ivrName, settings);
  });
  c.find('#remove_ivr').on('click', function() {
    if(confirm(translate('askremoveivr') + ' ' + ivrName + '?')) {
      // remove ivrTable records for current ivr
      var tableKeys = Object.keys(ivrTable);
      for(var i = 0; i < tableKeys.length; ++i) {
        if(ivrTable[tableKeys[i]] == ivrName) delete ivrTable[tableKeys[i]];
      }
      updateSettings('ivr', ivrTableName, ivrTable);
      removeObject('ivr', ivrName);
      c.remove();
    }
  });
  c.children('div').fadeIn('slow');
  c.find('.list_settings .head').trigger('click');
}

function isProperNum(num) {
  //if(/[\.\,\:\'\"\/\\\!\#\%\^\&\*\(\)\=\-\_\?\|\[\]\$\^\~\`]/.test(num) || num == '' || !num) {
  if(/[\,\:\'\"\/\\\!\#\^\&\*\(\)\=\?\|\[\]\$\^\~\`]/.test(num) || num == '' || !num) {
    return false;
  } else {
    return true;
  }
}

function getFileList(c) {
  var result = [];
  c.find('span').each(function() {
    result.push($(this).attr('data-value'));
  });
  return result;
}

function propagateFileList(c, list) {
  if(!list || !list.length) return;
  for(var i = 0; i < list.length; i++) {
    c.append(
      '<span data-value="' + list[i] + '"><a class="grey pointer xIcon">' + list[i] + '</a></span>'
    );
  }
}

function propagateActionParam(c, param) {
  if(!param) return;
  if(typeof(param) == 'object') {
    // file list
    propagateFileList(c.find('.fileList'), param);
  } else {
    // string
    c.find('.dest').val(param);
  }
}

function listSoundFiles(l) {
  $('.pbxListContainer').html(
    '<div class="scrollList"><div id="pbxList"><div class="loader"></div></div></div>'
  );
  var c = $('.pbxFiles #pbxList');
  setTimeout(function() {
    c.html('');
    for(var i = 0; i < l.length; i++) {
      c.append('<p class="pointer"><a>' + l[i] + '</a></p>');
    }
    c.parent().jScrollPane();
    c.find('p').on('click', function() {
      fileListCont.append('<span data-value="' + $(this).text() + '">' +
        '<a class="grey pointer xIcon">' + $(this).text() + '</a></span>');
      fileListCont.find('.xIcon:last-child').on('click', function() {
        $(this).parent().remove();
      });
    });
  },500);
}

function ivr_action_params() {
  return '<input class="dest bg input" type="text" size="10" style="display:none" />' +
    '<span class="file" style="display:none"><span class="fileList"></span> ' +
    '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></span>';
}
function ivr_preplay() {
  return '<span class="preplay"><span class="file"><span class="fileList"></span> ' +
  '<a class="addFile yellow border pointer">' + translate('addfile') + '</a></span></span>';
}
function ivr_actions(incNone) {
  return '<span class="select"><select class="action">' +
    (incNone ? '<option value="">' + translate('none') + '</option>' : '') +
    '<option value="hangup">' + translate('hangup') + '</option>' +
    '<option value="ivr">' + translate('playivr') + '</option>' +
    //'<option value="play">' + translate('playfile') + '</option>' +
    '<option value="call">' + translate('transferto') + '</option>' +
    '<option value="sendurl">' + translate('sendurl') + '</option></select></span>';
}
function ivr_lang() {
  return '<span class="select"><select class="language"><option value="">' + translate('none') + '</option>' +
    '<option value="english">' + translate('english') + '</option>' +
    '<option value="german">' + translate('german') + '</option>' +
    '<option value="russian">' + translate('russian') + '</option>' +
    '</select></span>';
}

function displayIvrList(list) {
  var ivrList = $('#ivrList');
  ivrList.html('<table width="100%" cellspacing="0" cellpadding="0">' +
    '<thead><td>' + translate('ivrmenu') + '</td><td>' + translate('ivrnumbers') + '</td></thead>' +
    '<tbody></tbody></table>'
  );
  if(getKeysCount(list)) {
    var listKeys = Object.keys(list);
    var iKey;
    for(var i = 0; i < listKeys.length; ++i) {
      iKey = listKeys[i];
      ivrList.find('tbody').append(
        '<tr data-value="' + iKey + '" class="pointer"><td><a>' + iKey + '</a></td>' +
        '<td>' + list[iKey].join(',') + '</td></tr>'
      );
    }
    var jspElem = ivrList.parents('.scrollList').jScrollPane();
    jspApi = jspElem.data('jsp');
    ivrList.find('tr').on('click', function(e) {
      e.preventDefault();
      if(!$(this).attr('data-value')) return;
      if(!$(this).hasClass('bg')) {
        $(this).addClass('bg').siblings('.bg').removeClass('bg');
      }
      var ivrName = $(this).attr('data-value');
      var c = $('.ivrSettings');
      if(!c.length) {
        $('#tabIvr').append(
          '<div class="ivrSettings bg standheight left twothirdwidth">' +
          '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
          '<div class="loader"></div></div>'
        );
      } else {
        c.html('<a class="closeIcon right pointer marg20" title="' + translate('close') +
          '"></a><div class="loader"></div>'
        );
      }
      c.find('.closeIcon').on('click', function() {
        $(this).parent().remove();
        ivrList.find('.bg').removeClass('bg');
      });
      getSettings('ivr', ivrName);
    });
    if(curIvr) {
      ivrList.find('tr[data-value="' + curIvr + '"]').trigger('click');
      curIvr = null;
    }
    closeOverlay();
  }
}
function addFileHandler(sel) {
  fileListCont = sel.siblings('.fileList');
  if(!$('#tabIvr .pbxFiles').length) {
    $('#tabIvr').prepend('<div class="pbxFiles right onethirdwidth bg standheight">' +
      '<a class="closeIcon right pointer marg20" title="' + translate('close') + '"></a>' +
      '<div class="marg20"><h2>' + translate('pbxlist') + ' ' + domainName + '</h2>' +
      '<i class="description">' + translate('pbxlistinstruction') + '</i><br />' +
      '<div class="pbxListContainer">' +
      '<div class="scrollList"><div id="pbxList"><div class="loader"></div></div></div>' +
      '</div><br />' +
      '<p><button id="upload_file" class="button ff0">'+translate('uploadfile')+'</button> ' +
      '<input type="file" id="upload_pbx" style="display:none" />' +
      '<span style="color: #FFF;" class="select setMinWidth right">' +
      '<select id="pbxEnv" class="language">' +
      '<option value="">' + translate('default') + ' (' + translate('english') + ')</option>' +
      '<option value="german">' + translate('german') + '</option>' +
      '<option value="russian">' + translate('russian') + '</option>' +
      '</select></span>' +
      '</p></div></div>'
    );
    //$('.pbxFiles').css('height', $('.ivrSettings').height());
    $('#tabIvr .ivrListContainer').hide();
    select_html($('#pbxEnv').parent());
    $('#pbxEnv').on('change', function() {
      getSoundFiles($(this).val());
    });
    $('.pbxFiles .closeIcon').on('click', function() {
      $(this).parent().remove();
      $('#tabIvr .ivrListContainer').show();
      $window.trigger('resize');
    });
    $(document).trigger('scroll');
    getSoundFiles();
    $('#upload_file').on('click', function() {
      $('#upload_pbx').trigger('click');
    });
    $('#upload_pbx').on('change', function() {
      var file = this.files[0];
      var fileName = file.name.toLowerCase();
      var reader = new FileReader();
      reader.onloadend = function() {
        var data = reader.result;
        data = data.substring(data.indexOf(',') + 1);
        var lang = $('#pbxEnv').val();
        uploadSoundFile((lang ? lang + '/' : '') + fileName, data);
      }
      if(file && fileName) {
        reader.readAsDataURL(file);
      } else {
        return false;
      }
    });
  } else {
    $('#tabIvr .pbxFiles').hide();
    $('#tabIvr .pbxFiles').fadeIn('slow');
  }
}
function getHrs(t) {
  return Math.floor(+t/3600);
}
function getMnts(t) {
  return Math.floor((t - getHrs(t)*3600)/60);
}
